#include "hexagon.h"

#include "tap.h"

int searchbound(int low, int high) {
	int try;

	while (low != high - 1) {
		try = (low + high) / 2;
		if (HL_map_bounds_ok(try,try)) {
			low = try;
		} else {
			high = try;
		}
	}
	return low;
}

int main(void) {
	int start;
	int x;

	plan_tests(2);

	x = 1;
	do {
		x = x * 2;
	} while (HL_map_bounds_ok(x,x));
	x = searchbound(x/2, x);
	ok(x == HL_map_max_dimension(), "checking HL_map_max_dimension()");

	start = HL_cantor_xy(x,x);
	ok(start > 0, "maximum cantor size is greater than zero");

	return 0;
}
